
#ifndef __ADAPT_H
#define __ADAPT_H

#include <values.h>
#include "ipp.h"

#define CHANGE_INITIAL	2  
#define CHANGE_GOAL     3  
#define TIMEOUT         4
#define PARTIAL_TIMEOUT 5

#define IS_USED 1
#define CUT_OFF 2

#define MAX_SIZE 3
#define STEP     2

#define FWD     1
#define BACK    2

int backtrack, tot_backtrack;
int *backtrack_list;
int cut_off;
int iniz_step_cut, step_cut;

struct tms start_time, search_start;
float build_ad_time, build_time;
  
typedef struct ACTION  
{  
   int iPasso;
   char cStr[256];  
   struct ACTION *psaNext;  
} action;  

action *psaFirst, *psaLast, *a;  
action *act_vect[MAX_PLAN+1];   
  
int incons_vect[MAX_PLAN+1];
int correct_vect[MAX_PLAN+1];

token_list store_goal_facts, store_initial_facts;
token_list fact_table_vect[MAX_PLAN+1], goal_table_vect[MAX_PLAN+1];
 
struct ADAPT 
{ 
   int plan_length;  
   int curr_plan_length; 
   int best_plan_length;
   int change;  
   int step;
   int timeout;
   int partial_timeout;
   int num_inc;  
   int num_actions;
   int best_num_actions;
   int alterna;
   int iteraz;
   int try;
  /* define the type of levels that has been considered in the optimization */
} adapt;


/* in file load.c */

void load_plan(char *file_plan);
void store_adapted_plan(int levels, char* fact_file_name, double time);


/* in file adapt.c */

BOOLEAN adapt_plan(int curr_init_time);
int resize_plan(char* file_name);

int insert_actions(action *psaFirst, int min_time);  
void insert_operators(vertex_list op, int time);  
void find_fact_goal_op(int time_in, int time_end, int pos);
void define_facts(int init_time, int tot_time);
int end_control();


/* in file util_adapt.c */

void insert_act_vect(token name, int level) ;
void free_act_vect(int level);
void up_act_vect(int level);
void down_act_vect(int level);

void insert_noop(int init, int end);
void ins_noop_layer(int time);
BOOLEAN me_op(vertex_list op, int time);
BOOLEAN me_noop(vertex_list op, int time);
BOOLEAN me_fct(vertex_list fct, int time);
void insert_incons(int time);
void del_inc(int time);
int choose_inc();

void de_alloc(int max_time);
void free_table(hashtable *t, int max_size);
void free_edge_list(edge_list e);
void free_cond_edge_list(cond_edge_list ce);
void free_delete_list(delete_list de);
void free_vertex(vertex_list v);

void print_plan(int time);
void print_partial_plan(int time);
void print_facts_and_goals(int curr_init_time, int curr_max_time);
void print_list(token_list list);


/* in file main.c */

void print_adj_report(float plan_time);


#endif __ADAPT_H

