
#include "adapt.h"


FILE* open_plan_file(char* file_name)
{ 

  FILE* fp; 
 
  fp = fopen(file_name,"r");
  
  if(fp==NULL) 
  {
    printf("\nADJ: can't find plan file %s ! \n\n", file_name);
    exit (2);
  } 
  
  return (fp); 
} 

 
int test_level(char* cStr)
{ 
  int i; 
 
  if(cStr[strlen(cStr)-1] == ':')
     i = 1; 
  else
     i = 0;

  return(i);
} 

 
int estract_level(char* cStr)
{ 
  int n,m; 
   
  n = strlen(cStr) - 1; 
  cStr[n]='\n'; 
  m=atoi(cStr);

  return(m); 
} 



// Search for comment in the input file : they starts whith '#'

void skip_comment(FILE* fp)
{

  char charact;
  
  charact = fgetc(fp);       

  if (charact == '#')
  {     
     while ( charact != '\n' )
        charact = fgetc(fp);       
  }

}

 
void actions_list(FILE* fp)
{ 
  int iN,iErr,i;
  int iPrimo=1;
  char cStr[256];

  action* a; 

  iErr=0; 
  psaFirst = NULL; 
  psaLast = NULL;
 
 
  while(!feof(fp)&&!iErr) 
  { 

     skip_comment(fp);

     fscanf(fp,"%s",cStr);

     if (test_level(cStr))
     {
       iN = estract_level(cStr);
       fscanf(fp,"%s",cStr);
     }

     a = ((action*) malloc(sizeof(action)));

     if(a==NULL)
       iErr=1;
     else
     {
        for(i=0;i<strlen(cStr);i++)
          a->cStr[i] = cStr[i];

        a->cStr[i]='\0';
        a->psaNext = NULL;
        a->iPasso = iN;
	
        if(iPrimo)
        {
      	  psaFirst = psaLast = a; 
          iPrimo = 0; 
        }
        else
        {
          psaLast->psaNext = a; 
	  psaLast = a; 
        }
     }
  } 
  if(iErr)
     exit(3);
} 
 

// Load input plan file

void load_plan(char* plan_file) 
{

  FILE* pFile;

  pFile = open_plan_file(plan_file);
  actions_list(pFile);
  fclose(pFile);

} 


// Store adapted plan on file

void store_adapted_plan(int levels, char* fact_file_name, double time)
{

  int i;
  char cNameFile[30];
  static int num_plan=0;
  FILE* fp;

  action *temp_act;
    
  num_plan++;

  sprintf(cNameFile,"plan_%s_%d.SOL\0",fact_file_name,num_plan);
  if((fp = fopen( cNameFile, "w")) == NULL)
  {
      printf("\nERROR: cannot open file ! \n\n");
      exit(1);
  }
  fprintf(fp,"#Problem:\t%s\t time:\t%f\t levels:\t%d\n", fact_file_name, time, levels);

  /* for all non empty operator levels */ 
  for ( i=0; i<levels; i++ )
  { 
     fprintf(fp,"%3d: ", i); 

     /* for all operators in plan */
     for(temp_act = act_vect[i]; temp_act; temp_act = temp_act->psaNext)
     {
        fprintf(fp,"\t%s\n", temp_act->cStr );
     }

  }
  
  fclose(fp);
}  











